// Get all parameters -- settings, and hook-specific values
// Note: settings will always be turned into initialLowerCamelCase even if they are
// specified as "Initial Lower Camel Case" in the info.plist file.
dim pUserName as string = Setting("username")
dim pToken as string = Setting("token")
dim pCompanyId as string = Setting("companyId")
dim pUserId as string = Setting("userId")
dim pTaskId as string = Setting2("taskId", "26-iIx--hnUw")
dim pStartDate as string = Param("startDate")
dim pEndDate as string = Param("endDate")


if pUserName = "" then
	MsgBox("Username must be set in settings")
    ScriptComplete(-1)
	return
end if

if pCompanyId = "" then
	MsgBox("Company Id must be set in settings")
    ScriptComplete(-1)
	return
end if

if pToken = "" then
	MsgBox("Token must be set in settings")
	ScriptComplete(-1)
    return
end if

if pUserId  = "" then
	MsgBox("User Id must be set in settings")
    ScriptComplete(-1)
	return
end if

// Create constants for fixed objects that we always use
// Dicts
#declare kJobs 1
// Http
#declare kHttp 0
// Json
#declare kApiResult 0

// Open rest device using the user-specified resource as a base URL
call HttpCreateFromSetting(kHttp, "baseURL")

// Request headers are cached by the Rest device and used for all requests
HttpSetRequestHeader(kHttp, "Authorization", "Basic " + Base64(pUserName + ":" + pToken))
HttpSetRequestHeader(kHttp, "Content-Type", "application/json")

// Get list of jobs from ClickTime for mapping of job name to ClickTime JobID
call DictionaryCreate(kJobs)
dim jobsJson as string
jobsJson = HttpDoGetRequest(kHttp, "Companies/" + pCompanyId + "/Users/" + pUserId + "/Jobs", 10)
'Log("ClickTime jobs: " + jobsJson)
call JsonParse(kApiResult, jobsJson)
'Log("JSON out: " + JsonToString(kApiResult))
'Log("ClickTime Job Count: " + Str(JsonCount(kApiResult)))
dim count as integer = 0
'Log("Job name in nnScreenshots must exactly match one of these names to be imported")
for jobIdx as integer = 0 to JsonCount(kApiResult)-1
	count = count + 1
	'Log("== " + Str(count) + " ==")
	dim jobJson as integer = JsonGetElementAt(kApiResult, jobIdx)
	dim jobName as string = JsonGetString(jobJson, "DisplayName")
	dim jobId as string = JsonGetString(jobJson, "JobID")
	Print(jobName)	' Send to hook
'	Log(jobName)	' Send to log for user benefit
	DictionarySetString(kJobs, jobName, jobId) 
	JsonClose(jobJson)
next
'Log("== End of Job List ==")
JsonClose(kApiResult)

ScriptComplete(0)
