dim separator as string = Setting("Separator")
dim quoteSeparators as boolean = Setting("Quote Separators") = "1"
dim quoteChar as string = Setting("Quote Character")
dim escapeQuotes as boolean = Setting("Escape Quotes") = "1"
dim escapeChar as string = Setting("Escape Character")
print "Settings: " + separator + If(quoteSeparators, "1", "0") + quoteChar + If(escapeQuotes, "1", "0") + escapeChar

' Trigger a Save As dialog with the user's Default Filename as the suggested file
dim h as integer = Open("defaultFilename", "saveas")
print "File handle: " + str(h)
if h = 0 or h = -1 then 
    ScriptComplete(kSilentError)
    return
end if

call WriteLn(h, "date" + separator + "job" + separator + "entry"+ separator + "start" + separator + "duration")

call FirstRecord()
for i as integer = 0 to RecordCount()-1
	dim dt() as string = split(FieldValue("dateTime"), " ")
	dim date as string = dt(0)
	dim job as string = GetActivity(Val(FieldValue("activityId")), "name")
	dim entry as string = FieldValue("entry")
	dim start as string = dt(1)
	dim duration as string = FieldValue("duration")

	if escapeQuotes then
		date = ReplaceAll(date, quoteChar, escapeChar + quoteChar)
		job = ReplaceAll(date, quoteChar, escapeChar + quoteChar)
		entry = ReplaceAll(date, quoteChar, escapeChar + quoteChar)
		start = ReplaceAll(date, quoteChar, escapeChar + quoteChar)
		duration = ReplaceAll(date, quoteChar, escapeChar + quoteChar)
	end if

	if quoteSeparators then
		if InStr(date, separator) > 0 then date = quoteChar + date + quoteChar
		if InStr(job, separator) > 0 then job = quoteChar + job + quoteChar
		if InStr(entry, separator) > 0 then entry = quoteChar + entry + quoteChar
		if InStr(start, separator) > 0 then start = quoteChar + start + quoteChar
		if InStr(duration, separator) > 0 then duration = quoteChar + duration + quoteChar
	end if

	call WriteLn(h, date + separator + job + separator + entry + separator + start + separator + duration)
	call NextRecord()
next

call Close(h)

ScriptComplete(kNoError)
